<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="formRecordId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'name'">
              <a @click="openPreview(record.path)">{{ record.name }}</a>
            </template>
            <template v-if="column.key === 'path'">
              <span class="ele-text-placeholder">{{ record.path }}</span>
            </template>
            <template v-if="column.key === 'component'">
              <span class="ele-text-placeholder">{{ record.component }}</span>
            </template>
            <template v-if="column.key === 'photo'">
              <a-image :src="record.photo" :width="180" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a
                  v-if="record.status == 1"
                  @click="openEdit(record)"
                  class="ele-text-success"
                  >已处理</a
                >
                <template v-if="record.status == 0">
                  <a
                    v-if="record.status == 0"
                    @click="openEdit(record)"
                    class="ele-text-warning"
                    >待处理</a
                  >
                  <a-divider type="vertical" />
                  <a-popconfirm
                    title="确定要删除此记录吗？"
                    @confirm="remove(record)"
                  >
                    <a class="ele-text-danger">删除</a>
                  </a-popconfirm>
                </template>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <FormRecordEdit
        v-model:visible="showEdit"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import FormRecordEdit from './components/form-record-edit.vue';
  import {
    pageFormRecord,
    removeFormRecord,
    removeBatchFormRecord
  } from '@/api/cms/form-record';
  import type {
    FormRecord,
    FormRecordParam
  } from '@/api/cms/form-record/model';
  import { useRouter } from 'vue-router';
  import { openPreview } from '@/utils/common';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<FormRecord[]>([]);
  // 当前编辑数据
  const current = ref<FormRecord | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  const domain = localStorage.getItem('Domain');

  // 加载状态
  const loading = ref(true);
  const { push } = useRouter();

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageFormRecord({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      width: 90,
      dataIndex: 'formRecordId'
    },
    {
      title: '手机号码',
      dataIndex: 'phone',
      width: 180,
      key: 'phone'
    },
    {
      title: '姓名',
      dataIndex: 'name',
      key: 'name'
    },
    {
      title: '其他数据',
      dataIndex: 'component',
      key: 'component'
    },
    // {
    //   title: '状态',
    //   dataIndex: 'status',
    //   width: 120,
    //   align: 'center',
    //   key: 'status'
    // },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      align: 'center',
      width: 120,
      showSorterTooltip: false
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: FormRecordParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: FormRecord) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  const openFormRecord = (row?: FormRecord) => {
    push({
      path: '/cms/form-record/detail',
      query: { id: row?.formRecordId }
    });
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: FormRecord) => {
    const hide = message.loading('请求中..', 0);
    removeFormRecord(row.formRecordId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchFormRecord(selection.value.map((d) => d.formRecordId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: FormRecord) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };

  query();
</script>

<script lang="ts">
  export default {
    name: 'FormRecord'
  };
</script>

<style lang="less" scoped>
  .sys-org-table :deep(.ant-table-body) {
    overflow: auto !important;
    overflow: overlay !important;
  }

  .sys-org-table :deep(.ant-table-pagination.ant-pagination) {
    padding: 0 4px;
    margin-bottom: 0;
  }
  :deep(.ant-image-img) {
    max-height: 80px;
  }
</style>
